<!-- Based on fast/repaint/align-self-overflow-change.html -->
<!DOCTYPE HTML>
<script src="resources/paint-invalidation-test.js"></script>
<script>
window.expectedPaintInvalidationObjects = [
    "LayoutBlockFlow BODY",
    "LayoutGrid DIV id='container'",
    "LayoutBlockFlow DIV class='item1'",
    "LayoutBlockFlow DIV",
    "LayoutBlockFlow DIV class='item2'",
];
function paintInvalidationTest() {
  document.getElementsByClassName('item1')[0].style.alignSelf = 'end safe';
  document.getElementsByClassName('item2')[0].style.alignSelf = 'end safe';
}
onload = runPaintInvalidationTest;
</script>
<style>
body {
  margin: 0;
}
#container {
  display: grid;
  grid: 200px / 150px 150px;
  width: 200px;
  height: 300px;
  background-color: red;
}
.item1 {
  grid-row: 1;
  grid-column: 1;
  align-self: end true;
  background-color: green;
}
.item2 {
  grid-row: 2;
  grid-column: 1;
  align-self: end true;
  background-color: green;
</style>
<p style="height: 20px">Tests invalidation on align-self style change (just overflow). Passes if there is no red.</p>
<div id="container">
  <div class="item1">
    <div style="height: 200px"></div>
  </div>
  <div class="item2">
    <div style="height: 100px"></div>
  </div>
</div>
